
require("mod-gui")

require("util")

require("production-score")

require("drift")

local price_list = {}

local entities_weight_tables = {}

script.on_init(function()

    price_list = production_score.generate_price_list()

    function generateWeightTable(entities)
        local score_neg_sum = 0
        for _, name in pairs(entities) do
            local score_neg = 1 / price_list[name]
            score_neg_sum = score_neg_sum + score_neg
        end
        local weights = {}
        for _, name in pairs(entities) do
            local score_neg = 1 / price_list[name] -- doublicate
            local weight = score_neg / score_neg_sum
            weights[name] = weight
        end
        return weights
    end

    -- Manually selected entity names to be choosen from in the tree replacement...
    local entities = {
        -- "wooden-chest",
        "small-electric-pole",
        "medium-electric-pole",
        "big-electric-pole",
        "substation",
        "roboport"
    }

    local entities_weight = generateWeightTable(entities)

    entities_weight_tables[1] = entities_weight

end)

script.on_event(defines.events.on_chunk_generated, function(event)

    local area = event.area

    local surface = event.surface

    local entities = surface.find_entities(area)

    -- #1 -- tree replacement

    -- for _, entity in pairs(entities) do

    --     if entity.type == "tree" then

    --         local position = entity.position

    --         entity.destroy()

    --         local random = math.random()

    --         local result

    --         local temp = 0

    --         for name, weight in pairs(entities_weight_tables[1]) do

    --             if random > temp and random <= temp + weight then

    --                 result = name

    --             end

    --             temp = temp + weight

    --         end

    --         local LuaEntity = {}

    --         LuaEntity.name = result

    --         LuaEntity.position = position

    --         LuaEntity.force = "neutral"

    --         -- if LuaEntity.name == "roboport" then

    --         --     game.print("roboport" .. math.random())

    --         -- end

    --         if surface.can_place_entity(LuaEntity) then

    --             surface.create_entity(LuaEntity)

    --         else

    --             -- game.print( "could'nt place entity" .. math.random())

    --             local radius = 32

    --             local position = surface.find_non_colliding_position(LuaEntity.name, LuaEntity.position, radius, 1)

    --             if position then

    --                 -- game.print( "found new position" .. math.random())

    --                 -- local LuaEntity = {}

    --                 -- LuaEntity.name = result

    --                 LuaEntity.position = position

    --                 -- LuaEntity.force = "neutral"

    --                 if surface.can_place_entity(LuaEntity) then

    --                     surface.create_entity(LuaEntity)

    --                 end

    --             else

    --                 -- game.print( "didn't find new position" .. math.random())

    --             end

    --         end

    --     end

    -- end

end)

script.on_event(defines.events.on_player_created, function(event)

    local player = game.players[event.player_index]

    local surface = player.surface

    -- player.character_running_speed_modifier = 10

    local start_inventory = {

        ["offshore-pump"] = 1,

        -- ["iron-axe"] = 1,

        ["small-electric-pole"] = 15,

        ["boiler"] = 4,

        ["burner-inserter"] = 4,

        ["steam-engine"] = 8,

        ["pipe"] = 10,

        ["pipe-to-ground"] = 2,

        ["coal"] = 50,

        ["iron-plate"] = 8,

        ["car"] = 1,

        ["steel-axe"] = 1,

        ["submachine-gun"] = 1,

        ["piercing-rounds-magazine"] = 50,

        ["transport-belt"] = 100

    }

    for item, count in pairs(start_inventory) do

        player.insert({name = item, count = count})

    end

    local LuaGuiElement = {}

    LuaGuiElement.type = "button"

    LuaGuiElement.name = "Hi_i_am_button_and_i_do_X"

    LuaGuiElement.caption = "Do X"

    mod_gui.get_button_flow(player).add{

        type = LuaGuiElement.type,

        name = LuaGuiElement.name,

        caption = LuaGuiElement.caption

    }

    -- local LuaGuiElement = {}

    -- LuaGuiElement.type = "button"

    -- LuaGuiElement.name = "toggle-drift"

    -- LuaGuiElement.caption = "toggle-drift"

    -- mod_gui.get_button_flow(player).add{

    --     type = LuaGuiElement.type,

    --     name = LuaGuiElement.name,

    --     caption = LuaGuiElement.caption

    -- }

    -- local LuaGuiElement = {}

    -- LuaGuiElement.type = "button"

    -- LuaGuiElement.name = "simulate-die"

    -- LuaGuiElement.caption = "simulate-die"

    -- mod_gui.get_button_flow(player).add{

    --     type = LuaGuiElement.type,

    --     name = LuaGuiElement.name,

    --     caption = LuaGuiElement.caption

    -- }

end)

script.on_event(defines.events.on_gui_click, function(event)

    local player = game.players[event.player_index]

    local LuaGuiElement = event.element

    if LuaGuiElement.name == "Hi_i_am_button_and_i_do_X" then

        local surface = player.surface

        local LuaCustomChartTag = {}

        LuaCustomChartTag.position = {0, 0}

        LuaCustomChartTag.text = "test"

        LuaCustomChartTag = player.force.add_chart_tag(surface, LuaCustomChartTag)

        if LuaCustomChartTag then

            game.print("success") -- this

        else

            game.print("failure")

        end

    elseif LuaGuiElement.name == "toggle-drift" then

        if global_drift then

            global_drift = false

        else

            global_drift = true

        end

        game.print("drift = " .. tostring(global_drift))

    elseif LuaGuiElement.name == "simulate-die" then

        player.character.die()

    end

end)

-- function printLuaGuiElement(LuaGuiElement)
--     local entries = {
--         "type",
--         "name",
--         "caption"
--     }
--     printTableEntries(LuaGuiElement, entries)
-- end

-- function printTableEntries(table, entries)
--     for _, value in pairs(entries) do
--         game.print(value .. ": " .. tostring(table[value]))
--     end
-- end